/* $Id: getspans.c,v 1.2 2006/01/21 16:17:15 cegger Exp $
***************************************************************************

   X server for LibGGI - Graphics acceleration

   Copyright (C) 1997	   Michael Krause	[rawstyle@ms.demo.org]
   Copyright (C) 1998-1999 Marcus Sundberg	[marcus@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

***************************************************************************
*/

#include "screen.h"

#if 0	/* Disabled, not yet proved that this works */
/*
 * xggiGetSpans - accelerated replacement for cfbGetSpans
 *
 */
void xggiGetSpans(
		DrawablePtr pDrawable,	/* drawable from which to get bits */
		int wMax,		/* largest value of all *pwidths */
		DDXPointPtr ppt,	/* points to start copying from */
		int *pwidth,		/* list of number of bits to copy */
		int nspans,		/* number of scanlines to copy */
		char *pchardstStart	/* where to put the bits */
		)
{
	int scr;
	int w;
	int left, top, right, bottom;

	scr = xggiGetScreenIdx(pDrawable->pScreen);

	ggiGetGCClipping(MASTER_VISUAL_VIS(scr),
			&left, &top, &right, &bottom);

	ErrorF("xggiGetSpans() called\n");

	while (nspans--) {
		w = MIN(ppt->x + *pwidth, right) - ppt->x;

		ggiGetHLine(MASTER_VISUAL_VIS(scr),
				ppt->x, ppt->y, w,
				(void *)pchardstStart);
		pchardstStart += w;
		pwidth++;
		ppt++;
	}	/* while */

	return;
}	/* xggiGetSpans */
#endif

